export function fileWrite(name, data) {
    plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function (fs) {
      fs.root.getFile(name + '.json', {
        create: true
      }, function (fileEntry) {
        fileEntry.file(function (file) {
          var fileWrite = new plus.io.FileWriter;
          fileEntry.createWriter(function (fileWrite) {
            fileWrite.write(data);
            fileWrite.onwrite = function (e) {
              alert("write ok");
            }
          })
        });
      });
    });
  };
  
  export function fileReader(name, callback) {
    plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function (fs) {
      fs.root.getFile(name + '.json', {
        create: true
      }, function (fileEntry) {
        fileEntry.file(function (file) {
          var fileReader = new plus.io.FileReader();
  
          fileReader.readAsText(file, 'utf-8');
          fileReader.onloadend = function (evt) {
            alert("reader ok");
            callback(evt.target.result)
            // 						var data = JSON.parse(evt.target.result)
  
          }
        });
      });
    });
  };
  export function fileDownload(downUrl, savePath, success, error,presence) {
		//处理链接后问号
		var allUrl = downUrl.split("?")[0]
		//获取文件名称
		var filename = allUrl.substring(
			allUrl.lastIndexOf("/") + 1,
			allUrl.length
		);
		//修改为本地路径
		var relativePath = "_downloads/" + savePath + filename;
		//检查文件是否已存在
		plus.io.resolveLocalFileSystemURL(
			relativePath,
			function(entry) {
				console.log(savePath + "文件存在=" + relativePath);
				//如果文件存在
				function callback(res) {
					presence(res)
				}
				setUrlFromLocal(relativePath, callback)

			},
			function(e) {
				console.log()
				console.log(savePath + "文件不存在,联网下载=" + relativePath);
				//如果文件不存在
				downloadLocal(relativePath, savePath, success)
			}
		);

		function downloadLocal(relativePath, savePath, success) {

			var dtask = plus.downloader.createDownload(
				allUrl, {
					method: "GET",
					filename: "_downloads/" + savePath
				},
				function(d, status) {
					if (status == 200) {
						//下载成功
						console.log("下载成功=" + relativePath);
						//d.filename  
						setUrlFromLocal(d.filename, callback)

						function callback(res) {
							success(res)
						}
					} else {
						//下载失败,需删除 本地临时文件,否则下次进来时会检查到文件已存在
						console.log("下载失败=" + status + "==" + relativePath);
						//dtask.abort();//文档描述:取消下载,删除临时文件(但经测试临时文件没有删除,故使用delFile()方法删除);
						error()
						if (relativePath != null) {
							delFile(relativePath);
						}
					}
				}
			);
			dtask.start();
		}
		//本地相对路径("_downloads/logo.jpg")转成SD卡绝对路径("/storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/downloads/logo.jpg");
		function setUrlFromLocal(relativePath, callback) {
			var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
			callback(sd_path)
		}

		function delFile(relativePath) {
			plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
				entry.remove(
					function(entry) {
						console.log("文件删除成功==" + relativePath);
					},
					function(e) {
						console.log("文件删除失败=" + relativePath);
					}
				);
			});
		}
	}